## xmds2 3.0.0+dfsg

=== xpdeint/support/wscript ===
#!/usr/bin/env python3
# encoding: utf-8
"""
wscript

The waf script to configure compilation of generated simulations.

Created by Graham Dennis on 2009-03-01.

Copyright (c) 2009-2012, Graham Dennis

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import os, sys, platform, re

from waflib import Task, TaskGen, Errors
from waflib.TaskGen import feature

def options(opt):
    # options provided by modules
    opt.load('compiler_cxx')

def optionAsList(var):
    if isinstance(var, str):
        return [var]
    elif isinstance(var, list):
        return var
    assert False


# This doesn't have great performance, but it's a small dataset we'll be working on
def append_to_unordered_set(dest, value):
    if value in dest:
        dest.remove(value)
    dest.append(value)

def expand_dependencies(dest, uselib, env):
    append_to_unordered_set(dest, uselib)
    if not uselib in env.uselib_dependencies: return
    expand_dependencies_of_list(dest, env.uselib_dependencies[uselib], env)

def expand_dependencies_of_list(dest, uselibs, env):
    for uselib in uselibs[:]:
        expand_dependencies(dest, uselib, env)


def configure(conf):
    env = conf.env
    
    env.uselib_dependencies = {}
    
    def _check_cxx(**KWs):
        # Don't execute when cross-compiling
        KWs['execute'] = not conf.env['is_cross_compile']
        KWs['mandatory'] = False
        KWs['ENVIRONMENT_NAME'] = conf.env['ENVIRONMENT_NAME']
        
        if 'cxxflags' in KWs:
          cxxflags = optionAsList(KWs['cxxflags'])
          
          linkflags = []
          if 'linkflags' in KWs:
            linkflags.extend(optionAsList(KWs['linkflags']))
          KWs['linkflags'] = linkflags
        
        original_uselib = []

        if 'uselib' in KWs:
            current_uselib = optionAsList(KWs['uselib'])
            original_uselib = current_uselib[:]
            expand_dependencies_of_list(current_uselib, original_uselib[:], conf.env)
            KWs['uselib'] = current_uselib
        
        result = conf.check_cxx(**KWs) not in [None, False]
        if result and 'uselib_store' in KWs:
            conf.env.append_unique('uselib', KWs['uselib_store'])
            if original_uselib:
                current_uselib_dep = conf.env.uselib_dependencies.setdefault(KWs['uselib_store'], [])
                for uselib in original_uselib:
                    if uselib == KWs['uselib_store']: continue
                    append_to_unordered_set(current_uselib_dep, uselib)
        return result
    
    def try_options(uselib_store, kwOptions, common = None):
        common = common or {}
        for kws in kwOptions:
            predicate = kws.get('predicate', True)
            if callable(predicate):
              predicate = predicate()
            if not predicate: continue
            
            allKWs = common.copy()
            allKWs.update(kws)
            if check_cxx(uselib_store=uselib_store, **allKWs):
                return True
        return False
    
    def check_cxx(**KWs):
        # Prefer a static library over a dynamic one if available
        if ('lib' not in KWs) or ('uselib_store' not in KWs) or ('_skip' in KWs):
            return _check_cxx(**KWs)
        
        lib = KWs['lib']
        del KWs['lib']
        uselib_store = KWs['uselib_store']
        KWs['_skip'] = True
        del KWs['uselib_store']
        extra_static_kws = KWs.get("static_lib_extra_options", {})
        extra_shared_kws = KWs.get("shared_lib_extra_options", {})
        
        options = [
            dict(stlib=lib, msg=KWs['msg'] + " (static library)", errmsg="no (will try dynamic library instead)", **extra_static_kws),
            dict(lib=lib,   msg=KWs['msg'] + " (dynamic library)", **extra_shared_kws),
        ]
        if not conf.env['STLIB_MARKER']:
            options = [
            # On systems like Mac OS X, it seems we can't force the linker to prefer static libraries over dynamic ones
            # Except of course by including them by listing the full path.
                dict(lib=lib, **extra_shared_kws),
            ]
        if not 'errmsg' in KWs:
            KWs['errmsg'] = "no (it's optional anyway)"
            
        return try_options(uselib_store, options, KWs)
    
    
    def configure_compiler():
        conf.load('compiler_cxx')
        
        conf.check_cxx(
            msg = "Checking whether the compiler works",
            errmsg = "The compiler doesn't seem to work"
        )
        
        conf.check_cxx(
            msg = "Checking that we have a C++ compiler",
            fragment = """
            #include <iostream>
            int main() { return 0; }
            """,
            errmsg = "Please specify a C++ compiler."
        )

        conf.env['is_cross_compile'] = not conf.check_cxx(
            msg = "Checking whether we are cross-compiling",
            okmsg = "no",
            errmsg = "maybe, assuming we are",
            execute = True,
            mandatory = False,
        )
        
        # If we have a static library marker, try to link the simulation statically for performance.
        if conf.env['STLIB_MARKER']:
            conf.env['FINAL_LINK_VAR'] = conf.env['STLIB_MARKER']
            result = conf.check_cxx(
                msg = "Checking whether we can link to only static libraries",
                errmsg = "no (will use dynamic libraries)",
                mandatory = False,
                execute = not conf.env['is_cross_compile']
            )
            if not result:
                del conf.env['FINAL_LINK_VAR']
        
        
        if conf.env['CXX_NAME'] == 'gcc' or conf.env['CXX_NAME'] == 'clang':

            machine_optimisations = [
                {
                    "msg": "Trying to make compiler optimise for this machine",
                    "cxxflags": "-march=native",
                },
                {
                    "msg": "Checking for Altivec",
                    "cxxflags": ['-mpim-altivec', '-maltivec'],
                },
                {
                    "msg": "Checking for AVX",
                    "cxxflags": ["-mavx", "-msse3", "-msse2", "-msse", "-mfpmath=sse"],
                },
                {
                    "msg": "Checking for SSE3",
                    "cxxflags": ["-msse3", "-msse2", "-msse", "-mfpmath=sse"],
                },
                {
                    "msg": "Checking for SSE2",
                    "cxxflags": ["-msse2", "-msse", "-mfpmath=sse"],
                },
                {
                    "msg": "Checking for SSE",
                    "cxxflags": ["-msse", "-mfpmath=sse"]
                }
            ]
            
            try_options('optimise', machine_optimisations,
                { # This is so that the compiler will generate SIMD instructions
                  # If the linker / assembler doesn't support those instructions,
                  # Then we'll pick it up this way.
                    "fragment": "int main() { double __volatile__ a = 1.0; a *= 1.03; return 0; }"
                }
            )
            
            check_cxx(
                cxxflags='-mtune=native',
                uselib_store="optimise",
                msg = "Trying to make compiler tune for this machine"
            )
            
            optimisation_flags = [
                '-O3', '-ffast-math', '-funroll-all-loops', '-fomit-frame-pointer', '-falign-loops', '-fstrict-aliasing', '-momit-leaf-frame-pointer'
            ]
            
            for optimisation_flag in optimisation_flags:
                check_cxx(
                    cxxflags=optimisation_flag,
                    uselib_store="optimise"
                )
            
            check_cxx(
                cxxflags=['-fno-unsafe-math-optimizations', '-fno-finite-math-only'],
                uselib_store="safe_math",
                msg = "Checking for cautious math flags"
            )
            
            if sys.platform == 'darwin':
                env.append_unique('CXXFLAGS', ['-mmacosx-version-min=%s' % '.'.join(platform.mac_ver()[0].split('.')[:2])])
            
            check_cxx(
                cxxflags='-ftree-vectorize',
                uselib_store='vectorise',
                uselib="optimise",
                msg = "Checking for Autovectorisation"
            )
            
            # Check for openMP on MacOS
            # Problem is that the default Apple compiler (clang) doesn't support openMP. We can force it to
            # recognise the OMP pragmas with the Xpreprocessor directive. This won't work with older versions
            # of OSX (difficult to tell how old because Apple doesn't version their clang the same way as
            # upstream clang, sigh.
            # This issue only exists for clang, so if the user is using gcc everything is fine.

            # Further edit: This almost works, but not quite. It fails one test in the test suite: openmp/eigenvalues.xmds
            # This script hangs forever at 100% cpu on all cores and does not finish. If I remove the <openmp \> from the script it
            # works fine. The generated C code looks fine and is identical to the code generated on a linux 
            # system where it works fine. The fail occurs in the nonlocal addressing line of the script, i.e.
            #   dmatrix_dt += _h_matrix_q...
            # If this line is commented out, everything if good. Possibly a Clang bug?
            # Until I figure out what the issue is, I'm backing out the change. If we want to enable OpenMP on
            # Mac again, just uncomment out the code below
 
            #if sys.platform == 'darwin' and conf.env['CXX_NAME'] == 'clang':
            #    check_cxx(
            #        cxxflags=['-Xpreprocessor', '-fopenmp'],
            #        linkflags=['-Xpreprocessor', '-fopenmp', '-lomp'],
            #        uselib_store='openmp',
            #        msg = "Checking for OpenMP"
            #    )
            #else:
            # Not using clang on MacOs, so just set up OpenMP in a normal sane fashion
            #    check_cxx(
            #        cxxflags='-fopenmp',
            #        linkflags="-fopenmp",
            #        uselib_store='openmp',
            #        msg = "Checking for OpenMP"
            #    )

            check_cxx(
                cxxflags='-fopenmp',
                linkflags="-fopenmp",
                uselib_store='openmp',
                msg = "Checking for OpenMP"
            )
            
            check_cxx(
                cxxflags="-pthread",
                linkflags="-pthread",
                uselib_store="threads",
                msg = "Checking for pthreads",
            )
        elif conf.env['CXX_NAME'] == 'icc':
            compiler_optimisations = [
                {
                    "msg": "Checking for the 'go fast' compiler option",
                    "cxxflags": ['-fast', '-ffast-math', '-complex-limited-range', '-fomit-frame-pointer'],
                    "linkflags": ["-fast"],
                },
                {
                    "msg": "Checking for fallback optimisation flags",
                    "cxxflags": ['-O3', '-ipo', '-ffast-math', '-complex-limited-range', '-fomit-frame-pointer'],
                    "linkflags": ['-O3'],
                },
                {
                    "msg": "Checking safe optimisation flags",

=== debian/changelog ===
xmds2 (3.0.0+dfsg-5) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.5.1 (no changes needed)
  * d/rules:
    + Do not run unit tests on ppc64el (Closes: #976950)
    + Use execute_(before|after)_dh_* targets instead of override_dh_*

 -- Rafael Laboissière <rafael@debian.org>  Sat, 02 Jan 2021 07:30:56 -0300

xmds2 (3.0.0+dfsg-4) unstable; urgency=medium

  * d/control:
    + Bump debhelper compatibitlity level to 13
    + Depends on libjs-sphinxdoc
  * d/u/metadata: Drop Name and Contact fields
  * Set Forwarded field to not-needed:
    + d/p/decrease-mpirun-slots.patch
    + d/p/deterministic-id.patch
    + d/p/no-generation-timestamps.patch
  * Use the system-installed JavaScript libraries
    + d/control: Build-depends on libjs-{jquery,underscore,sphinxdoc}
    + d/rules: Symlink to the appropriate *.js files

 -- Rafael Laboissière <rafael@debian.org>  Fri, 31 Jul 2020 12:01:01 -0300

xmds2 (3.0.0+dfsg-3) unstable; urgency=medium

  * d/control:
    + Build-depend and depend on python3-h5py-mpi (Closes: #938925)
    + Bump Standards-Version to 4.5.0 (no changes needed)
  * d/u/metadata: Add fields Bug-Submit, Repository, and Repository-Browse
  * d/p/is-operator-syntax-warning.patch: New patch
  * d/rules: Unset execute permission of wscript file.
    This complies with FHS 3.0, which specifies that files in /usr/lib
    should not be executable.
  * d/p/wscritp-no-shebang-line.patch: New patch
  * d/p/h5py-value-deprecation.patch: New patch

 -- Rafael Laboissière <rafael@debian.org>  Mon, 30 Mar 2020 05:01:43 -0300

xmds2 (3.0.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 07 Jul 2019 19:19:03 -0300

xmds2 (3.0.0+dfsg-1) experimental; urgency=medium

  * New upstream version 3.0.0+dfsg

 -- Rafael Laboissiere <rafael@debian.org>  Tue, 21 May 2019 11:37:25 -0300

xmds2 (2.3.0~rc1+dfsg-2) experimental; urgency=medium

  * d/p/compile-with-python3.patch: New patch (Closes: #929148)

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 19 May 2019 08:11:13 -0300

xmds2 (2.3.0~rc1+dfsg-1) experimental; urgency=medium

  * New upstream version 2.3.0~rc1+dfsg
  * d/copyright: Adjust list of files excluded from DFSG tarball
  * Refresh patches for new upstream version:
    + d/p/decrease-mpirun-slots.patch
    + d/p/no-parallel-waf-build.patch
    + d/p/revision-number-as-deb-pkg.patch
  * d/control: Adjust dependencies for Python 3
  * d/rules:
    + Use Python 3
    + Remove __pycache__ directories from binary package
  * d/clean: Remove Waf generated files

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 11 May 2019 06:37:30 -0300

xmds2 (2.2.3+dfsg-15) unstable; urgency=medium

  * d/p/no-parallel-waf-build.patch: New patch

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 19 Jan 2019 18:13:40 -0200

xmds2 (2.2.3+dfsg-14) unstable; urgency=medium

  * d/p/deterministic-id.patch: New patch

 -- Rafael Laboissiere <rafael@debian.org>  Fri, 18 Jan 2019 11:10:50 -0200

xmds2 (2.2.3+dfsg-13) unstable; urgency=medium

  * Avoid unreproducible strings in Cheetah generated files
    + d/fix-cheetah-build-str.py: Set the srcLastModified string to the
      date in d/changelog.  Also, remove the obsolete setting of the
      genTime* variables.
    + d/p/no-generation-timestamps.patch: New patch for adding the
      addTimestampsToCompilerOutput compiler option.

 -- Rafael Laboissiere <rafael@debian.org>  Wed, 16 Jan 2019 15:47:06 -0200

xmds2 (2.2.3+dfsg-12) unstable; urgency=medium

  * d/control: Bump debhelper compat level to 12
  * d/control: Bump Standards-Version to 4.3.0 (no changes needed)
  * d/p/decrease-mpirun-slots.patch: Extend the reduction of number of
    mpirun slots to a large numvber of unit tests.

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 10 Jan 2019 12:59:25 -0200

xmds2 (2.2.3+dfsg-11) unstable; urgency=medium

  * d/control:
    + Build-depend on python-scipy
    + Add Rules-Requires-Root: no
    + Bump Standards-Version to 4.2.1 (no changes needed)
  * d/p/decrease-mpirun-slots.patch: New patch
  * d/t/run-tests: Honor DEB_BUILD_OPTIONS=terse

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 02 Sep 2018 05:36:11 -0300

xmds2 (2.2.3+dfsg-10) unstable; urgency=medium

  * d/t/control: Add dependency on fonts-freefont-otf

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 23 Jun 2018 17:59:37 -0300

xmds2 (2.2.3+dfsg-9) unstable; urgency=medium

  * Build-depend on fonts-freefont-otf.
    Ensure that the plotting commands in unit test lorenz.m (Octave code)
    will work in an auto-build/autopkgtest environment.
  * Use correct version numbers in X-Python-Version header.
    Only versions present from oldstable until unstable are allowed in
    this field.
  * Proper dependencies on python-cheetah.
    The templates on which xmds2 is based need recompilation for each
    major version of the Cheetah engine.  We enforce now a strict
    dependency on the major of Cheetah with which the package is built.

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 23 Jun 2018 05:23:53 -0300

=== debian/control ===
Source: xmds2
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Rafael Laboissière <rafael@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               gnuplot-nox,
               fonts-freefont-otf,
               libfftw3-dev,
               libfftw3-mpi-dev,
               libgsl-dev,
               libhdf5-dev,
               libjs-jquery,
               libjs-underscore,
               libjs-sphinxdoc,
               libatlas-base-dev,
               mpi-default-bin,
               mpi-default-dev,
               octave,
               python3,
               python3-cheetah,
               python3-dateutil,
               python3-debian,
               python3-h5py-mpi,
               python3-lxml,
               python3-mpmath,
               python3-numpy,
               python3-pyparsing,
               python3-setuptools,
               python3-scipy
Standards-Version: 4.5.1
X-Python-Version: >= 3.7
Homepage: http://xmds.sourceforge.net/
Vcs-Git: https://salsa.debian.org/science-team/xmds2.git
Vcs-Browser: https://salsa.debian.org/science-team/xmds2
Rules-Requires-Root: no

Package: xmds2
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends},
         libfftw3-dev,
         libfftw3-mpi-dev,
         libgsl-dev,
         libhdf5-serial-dev,
         libatlas-base-dev,
         mpi-default-bin,
         mpi-default-dev,
         ${Cheetah-Depends},
         python3-h5py-mpi,
         python3-numpy,
         python3-lxml,
         python3-pkg-resources,
         g++
Suggests: python3-mpmath,
          python3-scipy
Description: eXtensible Multi-Dimensional Simulator
 XMDS is a code generator that integrates equations, from Ordinary
 Differential Equations (ODEs) up to stochastic Partial Differential
 Equations (PDEs). You write them down in human readable form in an
 XML file, and it goes away and writes and compiles a C++ program that
 integrates those equations as fast as it can possibly be done in your
 architecture.
 .
 XMDS 2 is a major upgrade rewritten in Python which is faster and far
 more versatile than previous versions, allowing the efficient integration
 of almost any initial value problem on regular domains.

Package: xmds2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-underscore,
         libjs-mathjax,
         libjs-sphinxdoc
Description: documentation for the eXtensible Multi-Dimensional Simulator
 XMDS is a code generator that integrates equations, from Ordinary
 Differential Equations (ODEs) up to stochastic Partial Differential
 Equations (PDEs). You write them down in human readable form in an
 XML file, and it goes away and writes and compiles a C++ program that
 integrates those equations as fast as it can possibly be done in your
 architecture.
 .
 XMDS 2 is a major upgrade rewritten in Python which is faster and far
 more versatile than previous versions, allowing the efficient integration
 of almost any initial value problem on regular domains.
 .
 This package contains the documentation in HTML and PDF formats.

=== debian/watch ===
version=4
opts="repack,compression=xz,uversionmangle=s/^xmds-/xmds2-/;s/-rc/~rc/,dversionmangle=s/[~+]dfsg[0-9]*//" \
  http://sf.net/xmds/xmds-([0-9].+)\.tar\.gz

## xmds2 3.1.0%2Bdfsg

=== xpdeint/wscript ===
#!/usr/bin/env python3
# encoding: utf-8
"""
wscript

The waf build script to compile all Cheetah templates.

Created by Graham Dennis on 2009-02-22.

Copyright (c) 2009-2012, Graham Dennis

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""

top = '.'
out = '.'

def options(opt):
    opt.load('cheetah', tooldir='waf_extensions')

def configure(conf):
    conf.load('cheetah', tooldir='waf_extensions')
    conf.env['CHEETAH_SETTINGS'] = {
            'directiveStartToken': '@',
            'commentStartToken': '@#',
            'multiLineCommentStartToken': '@*',
            'multiLineCommentEndToken': '*@',
        }

def build(bld):
    sources = bld.path.ant_glob('**/*.tmpl')
    if bld.cmd == 'clean':
        for n in sources:
            n.change_ext('.py').delete()
        for n in bld.path.ant_glob('**/*.pyc'):
            n.delete()
    else:
        bld(source=sources)

## xmds2 3.1.0+dfsg

=== debian/changelog ===
xmds2 (3.1.0+dfsg-3) unstable; urgency=medium

  * Reintroduce unit test involving Octave
  * d/s/lintian-overrides: Add override for
    very-long-line-length-in-source-file warnings

 -- Rafael Laboissière <rafael@debian.org>  Tue, 02 Nov 2021 03:47:20 -0300

xmds2 (3.1.0+dfsg-2) unstable; urgency=medium

  * d/copyright: Update Copyright years
  * d/s/lintian-overrides: Add override for license-problem-gfdl-invariants false positive

 -- Rafael Laboissière <rafael@debian.org>  Mon, 25 Oct 2021 02:03:41 -0300

xmds2 (3.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 3.1.0+dfsg
  * d/watch: Add repacksuffix option
  * d/copyright: Drop files removed from new upstream tarball
  * Drop patch (applied upstream)
    + d/p/compile-with-python3.patch
    + d/p/is-operator-syntax-warning.patch
    + d/p/h5py-value-deprecation.patch
    + d/p/non-ambiguous-global-variables.patch
  * d/rules: Drop code for removing __pycache__ directories before
    dh_installdeb

 -- Rafael Laboissière <rafael@debian.org>  Sun, 24 Oct 2021 12:10:24 -0300

xmds2 (3.0.0+dfsg-6) unstable; urgency=medium

  * d/control:
    + Build-depend on python3:any
    + Bump Standards-Version to 4.6.0 (no changes needed)
  * d/copyright: Update copyright year for debian/* files
  * d/p/non-ambiguous-global-variables.patch: New patch (Closes: #996279)
  * Temporarily disable the unit test involving Octave.
    The octave package is not installable in unstable right now, due to
    problems in current library transitions. The unit test in
    d/t/run-tests is commented out and the dependencies on octave are
    dropped.

 -- Rafael Laboissière <rafael@debian.org>  Sat, 23 Oct 2021 14:38:24 -0300

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                mpi-default-bin,
                mpi-default-dev,
                octave,
-               python3,
+               python3:any,
                python3-cheetah,
                python3-dateutil,
                python3-debian,
@@ -29,7 +29,7 @@
                python3-pyparsing,
                python3-setuptools,
                python3-scipy
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 X-Python-Version: >= 3.7
 Homepage: http://xmds.sourceforge.net/
 Vcs-Git: https://salsa.debian.org/science-team/xmds2.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#DH_VERBOSE=1

ifeq ($(dpkg-architecture -qDEB_BUILD_ARCH),ppc64el)
DEB_BUILD_MAINT_OPTIONS = nocheck
endif

%:
	dh $@ --with python3

override_dh_auto_install:
	python3 setup.py install --root=debian/xmds2 --install-layout=deb
	python3 debian/fix-cheetah-build-str.py

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	debian/tests/run-tests -b
endif

override_dh_auto_clean:
	cd xpdeint; waf/waf-light configure
	make clean
	dh_clean

JSDIR = /usr/share/javascript
INSTDIR = $(CURDIR)/debian/xmds2-doc
DOCDIR = $(INSTDIR)/usr/share/doc/xmds2
execute_after_dh_installdocs:
	# Fix Lintian error privacy-breach-may-use-debian-package
	sed -i 's|http://cdn.mathjax.org/mathjax/latest/|file:///usr/share/javascript/mathjax/|g;s|http://www.xmds.org/|file:///usr/share/doc/xmds2/|g' $(DOCDIR)/*.html $(DOCDIR)/_static/*.js
	# Symlink against the system-intalled JS libraries
	ln -fs $$(find $(JSDIR)/underscore -name underscore.js) $$(find $(INSTDIR) -name underscore.js)
	ln -fs $$(find -L $(JSDIR)/jquery -name jquery.js) $$(find $(INSTDIR) -name jquery.js)
	ln -fs $$(find $(JSDIR)/sphinxdoc -name doctools.js) $$(find $(INSTDIR) -name doctools.js)
	ln -fs $$(find $(JSDIR)/sphinxdoc -name searchtools.js) $$(find $(INSTDIR) -name searchtools.js)

CHEETAH_MAJOR_VERSION = $(shell dpkg -s python3-cheetah | grep ^Version: | cut -f2 -d\  | cut -f1 -d.)
override_dh_gencontrol:
	dh_gencontrol -- -VCheetah-Depends="python3-cheetah (>= $(CHEETAH_MAJOR_VERSION)), python3-cheetah (<< $$(($(CHEETAH_MAJOR_VERSION) + 1)))"

execute_before_dh_installdeb:
	# Make wscript non executable
	@echo "*********************************************************"
	@echo "Warning: check whether the following fix is still needed:"
	@echo "*********************************************************"
	find debian/xmds2 -name wscript -exec chmod -x '{}' \;

## xmds2 3.1.0+dfsg2

=== Makefile ===
SUBDIRS = xpdeint
PYTHON=python3
export PYTHON

.PHONY: all update clean check distclean

all:
	@for i in $(SUBDIRS); do \
	(cd $$i; $(MAKE) $(MFLAGS) all); done

update:
	@svn up
	@$(MAKE) $(MFLAGS) all

# remove all compiled files
clean:
	@for i in $(SUBDIRS); do \
	(cd $$i; $(MAKE) $(MFLAGS) clean); done

# check examples compile
check:
	@for i in $(SUBDIRS); do \
	(cd $$i; $(MAKE) $(MFLAGS) check); done

distclean:
	@for i in $(SUBDIRS); do \
	(cd $$i; $(MAKE) $(MFLAGS) distclean); done

=== src/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
#SPHINXBUILD   = sphinx-build
# Update build for Python 3
SPHINXBUILD = python3 -msphinx
PAPER         = a4

# Internal variables.
#PAPEROPT_a4     = -D latex_paper_size=a4
#PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d ../../documentation/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html web pickle htmlhelp latex changes linkcheck

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  pickle    to make pickle files (usable by e.g. sphinx-web)"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"

clean:
	-rm -rf ../../documentation

html:
	mkdir -p ../../documentation ../../documentation/doctrees
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) ../../documentation
	cp images/*.dia ../../documentation/_images/
	@echo
	@echo "Build finished. The HTML pages are in ../../documentation."

pickle:
	mkdir -p ../../documentation/pickle ../../documentation/doctrees
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) ../../documentation/pickle
	@echo
	@echo "Build finished; now you can process the pickle files or run"
	@echo "  sphinx-web ../../documentation/pickle"
	@echo "to start the sphinx-web server."

web: pickle

htmlhelp:
	mkdir -p ../../documentation ../../documentation/doctrees
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) ../../documentation
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in ../../documentation."

latex:
	mkdir -p ../../documentation/latex ../../documentation/doctrees
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) ../../documentation/latex
	@echo
	@echo "Build finished; the LaTeX files are in ../../documentation/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	mkdir -p ../../documentation/changes ../../documentation/doctrees
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) ../../documentation/changes
	@echo
	@echo "The overview file is in ../../documentation/changes."

linkcheck:
	mkdir -p ../../documentation/linkcheck ../../documentation/doctrees
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) ../../documentation/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in ../../documentation/linkcheck/output.txt."

=== xpdeint/Makefile ===
.PHONY: all update clean check distclean

all: wscript waf_extensions/cheetah.py c4che
	@$(PYTHON) waf/waf-light build
	@sh version.sh

update:
	@(cd ..; $(MAKE) $(MFLAGS) update;)

c4che: wscript waf_extensions/cheetah.py
	@$(PYTHON) waf/waf-light configure

clean:
	@$(PYTHON) waf/waf-light clean

# check examples compile
check:
	@for i in examples/*.xmds; do \
	echo $$i; xmds2 $$i; done

distclean:
	@$(PYTHON) waf/waf-light distclean

=== xpdeint/support/Makefile ===

all: xpdeint.rng

xpdeint.rng: xpdeint.rnc
	java -jar trang.jar xpdeint.rnc xpdeint.rng


clean:
	@rm xpdeint.rng

.PHONY: all clean

=== xpdeint/support/wscript ===
--- 
+++ 
@@ -249,38 +249,30 @@
             # of OSX (difficult to tell how old because Apple doesn't version their clang the same way as
             # upstream clang, sigh.
             # This issue only exists for clang, so if the user is using gcc everything is fine.
-
-            # Further edit: This almost works, but not quite. It fails one test in the test suite: openmp/eigenvalues.xmds
-            # This script hangs forever at 100% cpu on all cores and does not finish. If I remove the <openmp \> from the script it
-            # works fine. The generated C code looks fine and is identical to the code generated on a linux 
-            # system where it works fine. The fail occurs in the nonlocal addressing line of the script, i.e.
-            #   dmatrix_dt += _h_matrix_q...
-            # If this line is commented out, everything if good. Possibly a Clang bug?
-            # Until I figure out what the issue is, I'm backing out the change. If we want to enable OpenMP on
-            # Mac again, just uncomment out the code below
  
-            #if sys.platform == 'darwin' and conf.env['CXX_NAME'] == 'clang':
-            #    check_cxx(
-            #        cxxflags=['-Xpreprocessor', '-fopenmp'],
-            #        linkflags=['-Xpreprocessor', '-fopenmp', '-lomp'],
-            #        uselib_store='openmp',
-            #        msg = "Checking for OpenMP"
-            #    )
-            #else:
-            # Not using clang on MacOs, so just set up OpenMP in a normal sane fashion
-            #    check_cxx(
-            #        cxxflags='-fopenmp',
-            #        linkflags="-fopenmp",
-            #        uselib_store='openmp',
-            #        msg = "Checking for OpenMP"
-            #    )
-
-            check_cxx(
-                cxxflags='-fopenmp',
-                linkflags="-fopenmp",
-                uselib_store='openmp',
-                msg = "Checking for OpenMP"
-            )
+            if sys.platform == 'darwin' and conf.env['CXX_NAME'] == 'clang':
+                check_cxx(
+                    cxxflags=['-Xpreprocessor', '-fopenmp'],
+                    linkflags=['-Xpreprocessor', '-fopenmp', '-lomp'],
+                    uselib_store='openmp',
+                    msg = "Checking for OpenMP"
+                )
+            else:
+                # Not using clang on MacOs, so just set up OpenMP in a normal sane fashion
+                check_cxx(
+                    cxxflags='-fopenmp',
+                    linkflags="-fopenmp",
+                    uselib_store='openmp',
+                    msg = "Checking for OpenMP"
+                )
+
+            # This code is now superceded by the lines above
+            #check_cxx(
+            #    cxxflags='-fopenmp',
+            #    linkflags="-fopenmp",
+            #    uselib_store='openmp',
+            #    msg = "Checking for OpenMP"
+            #)
             
             check_cxx(
                 cxxflags="-pthread",
@@ -302,3 +294,25 @@
                 },
                 {
                     "msg": "Checking safe optimisation flags",
+                    "cxxflags": "-O3",
+                    "linkflags": "-O3"
+                }
+            ]
+            
+            try_options('optimise', compiler_optimisations)
+            
+            machine_optimisations = [
+                {
+                    "msg": "Trying to optimise for SSE4",
+                    "cxxflags": "-xS",
+                },
+                {
+                    "msg": "Trying to optimise for SSSE3",
+                    "cxxflags": "-xT",
+                },
+                {
+                    "msg": "Trying to optimise for SSE3",
+                    "cxxflags": "-xP",
+                },
+                {
+                    "msg": "Trying to optimise for SSE2",

=== debian/changelog ===
xmds2 (3.1.0+dfsg2-11) unstable; urgency=medium

  * d/control:
    + Bump Standards-Version to 4.7.2 (no changes needed)
    + Drop “Rules-Requires-Root: no”, which is now the default
    + Drop build-dependency on texlive-latex-base. This package is
      installed anyway because it is a dependency of latexmk.
    + Replace texlive-latex-recommended by texlive-latex-extra in
      Build-Depends
    + Mark the build-dependencies that are necessary only for building the
      documentation with the profile <!nodoc>
    + Mark the build-dependencies that are necessary only for running the
      test suite with the profile <!nocheck>
    + Promote enhancement packages from Suggests to Recommends
    + Promote libhdf5-mpi-dev and python3-h5py-mpi from Recommends to
      Depends
    + Demote python3-numpy and python3-lxml from Depends to Recommends
  * d/watch: Convert to format version 5
  * d/p/replace-deprecated-distutils.patch: New patch
  * d/s/lintian-overrides: Add overrides for the Lintian warning
    uses-deprecated-python-stdlib

 -- Rafael Laboissière <rafael@debian.org>  Fri, 26 Sep 2025 10:19:18 -0300

xmds2 (3.1.0+dfsg2-10) unstable; urgency=medium

  * Team upload.
  * debian/tests/run-tests: Allow oversubscription and set the SSH agent
    using the new environment variables for OpenMPI 5.

 -- Santiago Vila <sanvila@debian.org>  Mon, 04 Nov 2024 20:10:00 +0100

xmds2 (3.1.0+dfsg2-9) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.7.0 (no changes needed)
  * Use importlib.resources instead of pkg_resources (closes: #1083992)
    + d/control: Drop dependency on python3-pkg-resources
    + d/p/use-importlib-resources-module.patch: New patch
  * Add Applied-Upstream fields to the following patches:
    + d/p/do-not-use-imp-module.patch
    + d/p/extra-alignment-tab.patch
    + d/p/numpy-asscalar.patch
    + d/p/pygments-style-lexer.patch
  * d/p/drop-useless-imports.patch: New patch.
    This avoids the import of the deprecated module pipes. (Closes: #1084592)
  * d/p/invalid-escape-sequences.patch: New patch
  * d/rules: Improve message for chmod wscript

 -- Rafael Laboissière <rafael@debian.org>  Sat, 12 Oct 2024 10:23:40 -0300

xmds2 (3.1.0+dfsg2-8) unstable; urgency=medium

  * d/s/options: Do not exclude files under xpdeint/waf/
  * d/p/do-not-use-imp-module.patch: New patch (Closes: #1061766)
  * d/control: Drop unnecessary build-dependencies on
    libjs-{jquery,sphinxdoc,jquery}
  * Use dh_sphinxdoc instead of manually creating symlinks for *.js
    files

 -- Rafael Laboissière <rafael@debian.org>  Tue, 30 Jan 2024 11:29:12 -0300

xmds2 (3.1.0+dfsg2-7) unstable; urgency=medium

  * Simplify dependencies on hdf5 and h5py, related to MPI
    + d/p/h5py-always-use-mpi.patch: Drop patch
    + d/control:
      - Drop (build-)dependencies on both libhdf5-mpi-dev and
        python3-h5py-mpi.
      - Add versioned (build-)dependency (>= 3.9.0-4) on python3-h5py. This
        version of h5py contains a fallback mechanisms in both cases, when
        either python3-h5py-serial or python3-h5py-mpi are absent from the
        system.
      - Suggests libhdf5-mpi-dev and python3-h5py-mpi

 -- Rafael Laboissière <rafael@debian.org>  Fri, 13 Oct 2023 12:56:19 -0300

xmds2 (3.1.0+dfsg2-6) unstable; urgency=medium

  * d/control: Depend and Build-Depend on both libhdf5-dev and libhdf5-mpi-dev

 -- Rafael Laboissière <rafael@debian.org>  Tue, 10 Oct 2023 07:40:04 -0300

xmds2 (3.1.0+dfsg2-5) unstable; urgency=medium

  * Fix dependencies on h5py
    + d/control:
      - Build-depend on python3-h5py
      - Depend on libhdf5-mpi-dev
    + d/p/h5py-always-use-mpi.patch: New patch
    Thanks to Drew Parsons for the suggestions and Nilesh Patra for the
    discussion. (Closes: #1053314)

 -- Rafael Laboissière <rafael@debian.org>  Sun, 08 Oct 2023 14:24:24 -0300

xmds2 (3.1.0+dfsg2-4) unstable; urgency=medium

  * d/p/deterministic-id.patch: Fix typo in Forwarded field
  * Use OpenBLAS or BLIS instead of ATLAS
    + d/control: Depend and build-depend on libopenblas-dev |
      libblis-dev instead of libatlas-base-dev
    + d/p/vanilla-cblas.patch: New patch
  * d/control: Bump Standards-Version to 4.6.2 (no changes needed)
  * d/fix-cheetah-build-str.py:
    + Apply standard code conventions
    + Use `with` for resource-allocating operation
    + Specify UTF-8 encoding when opening files
    + Use f-strings instead of % operator
  * d/copyright: Update copyright year of debian/* files

 -- Rafael Laboissière <rafael@debian.org>  Mon, 17 Jul 2023 19:11:41 -0300

xmds2 (3.1.0+dfsg2-3) unstable; urgency=medium

  * d/p/numpy-asscalar.patch: New patch (Closes: #1026350)
  * d/clean: Remove _pygments/__pycache__ directory

 -- Rafael Laboissière <rafael@debian.org>  Tue, 20 Dec 2022 14:19:54 -0300

xmds2 (3.1.0+dfsg2-2) unstable; urgency=medium

  * Automate the generation of the orig-userdoc upstream tarball

 -- Rafael Laboissière <rafael@debian.org>  Mon, 05 Dec 2022 13:03:46 -0300

xmds2 (3.1.0+dfsg2-1) unstable; urgency=medium

  * New repackaged upstream version 3.1.0+dfsg2
  * d/control:
    + Update X-Python3-Version field
    + Bump Standards-Version to 4.6.1 (no changes needed)
    + Make package xmds2-doc Multi-Arch: foreign
  * d/s/lintian-overrides: Update overrides for new version of Lintian
  * d/copyright:
    + Exclude documentation directory from tarball and update
      Copyright notices for userdoc directory
    + Update Copyright years for debian/* files
    + Drop unused entries for JavaScript libraries
  * d/p/pygments-style-lexer.patch: New patch
  * d/p/extra-alignment-tab.patch: New patch
  * d/rules:
    + Build user documentation from source
    + Create symlink for file language_data.js
    + Do not compress file xmds_favicon.ico
  * d/control: Build-depend on packages needed for building the documentation
  * d/README.source: New scheme for building the documentation
  * d/s/lintian-overrides: Drop unused override for prebuiltsphinx doc


=== debian/control ===
Source: xmds2
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Rafael Laboissière <rafael@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               fonts-freefont-otf,
               gnuplot-nox <!nocheck>,
               latexmk <!nodoc>,
               libfftw3-dev <!nocheck>,
               libfftw3-mpi-dev <!nocheck>,
               libgsl-dev <!nocheck>,
               libhdf5-dev <!nocheck>,
               libopenblas-dev | libblis-dev <!nocheck>,
               mpi-default-bin <!nocheck>,
               mpi-default-dev <!nocheck>,
               octave <!nocheck>,
               python3:any,
               python3-cheetah,
               python3-dateutil,
               python3-debian,
               python3-h5py (>= 3.9.0-4) <!nocheck>,
               python3-lxml <!nocheck>,
               python3-mpmath <!nocheck>,
               python3-numpy <!nocheck>,
               python3-pyparsing <!nocheck>,
               python3-setuptools,
               python3-scipy <!nocheck>,
               python3-sphinx <!nodoc>,
               tex-gyre <!nodoc>,
               texlive-latex-extra <!nodoc>
Standards-Version: 4.7.2
X-Python3-Version: >= 3.7
Homepage: http://xmds.sourceforge.net/
Vcs-Git: https://salsa.debian.org/science-team/xmds2.git
Vcs-Browser: https://salsa.debian.org/science-team/xmds2

Package: xmds2
Architecture: all
Depends: ${python3:Depends},
         ${Cheetah-Depends},
         ${misc:Depends},
         g++,
         libfftw3-dev,
         libfftw3-mpi-dev,
         libgsl-dev,
         libhdf5-dev,
         libhdf5-mpi-dev,
         libopenblas-dev | libblis-dev,
         mpi-default-bin,
         mpi-default-dev,
         python3-h5py (>= 3.9.0-4),
         python3-h5py-mpi
Recommends: python3-lxml,
            python3-mpmath,
            python3-numpy,
            python3-scipy
Description: eXtensible Multi-Dimensional Simulator
 XMDS is a code generator that integrates equations, from Ordinary
 Differential Equations (ODEs) up to stochastic Partial Differential
 Equations (PDEs). You write them down in human readable form in an
 XML file, and it goes away and writes and compiles a C++ program that
 integrates those equations as fast as it can possibly be done in your
 architecture.
 .
 XMDS 2 is a major upgrade rewritten in Python which is faster and far
 more versatile than previous versions, allowing the efficient integration
 of almost any initial value problem on regular domains.

Package: xmds2-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax
Description: documentation for the eXtensible Multi-Dimensional Simulator
 XMDS is a code generator that integrates equations, from Ordinary
 Differential Equations (ODEs) up to stochastic Partial Differential
 Equations (PDEs). You write them down in human readable form in an
 XML file, and it goes away and writes and compiles a C++ program that
 integrates those equations as fast as it can possibly be done in your
 architecture.
 .
 XMDS 2 is a major upgrade rewritten in Python which is faster and far
 more versatile than previous versions, allowing the efficient integration
 of almost any initial value problem on regular domains.
 .
 This package contains the documentation in HTML and PDF formats.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#DH_VERBOSE=1

ifeq ($(dpkg-architecture -qDEB_BUILD_ARCH),ppc64el)
DEB_BUILD_MAINT_OPTIONS = nocheck
endif

%:
	dh $@ --with python3

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	make -C userdoc/src html latex
	make -C documentation/latex all-pdf

DOCDIR = $(CURDIR)/debian/xmds2-doc/usr/share/doc/xmds2
execute_after_dh_installdocs:
	# Fix Lintian error privacy-breach-may-use-debian-package
	sed -i 's|http://cdn.mathjax.org/mathjax/latest/|file:///usr/share/javascript/mathjax/|g;s|http://www.xmds.org/|file:///usr/share/doc/xmds2/|g' $(DOCDIR)/*.html $(DOCDIR)/_static/*.js
	dh_sphinxdoc
endif

override_dh_auto_install:
	python3 setup.py install --root=debian/xmds2 --install-layout=deb
	python3 debian/fix-cheetah-build-str.py

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	debian/tests/run-tests -b
endif

override_dh_compress:
	dh_compress -X.ico

CHEETAH_MAJOR_VERSION = $(shell dpkg -s python3-cheetah | grep ^Version: | cut -f2 -d\  | cut -f1 -d.)
override_dh_gencontrol:
	dh_gencontrol -- -VCheetah-Depends="python3-cheetah (>= $(CHEETAH_MAJOR_VERSION)), python3-cheetah (<< $$(($(CHEETAH_MAJOR_VERSION) + 1)))"

execute_before_dh_installdeb:
	# Make wscript non executable
	@wscript_path=$$(find debian/xmds2 -name wscript) ;	\
	if [ "$$(stat -c %a $$wscript_path)" = 644 ] ; then	\
	    echo "************************************" ;	\
	    echo "chmod wscript hack is no more needed" ;	\
	    echo "************************************" ;	\
	else 							\
	    chmod -x $$wscript_path ;				\
	fi

override_dh_auto_clean:
	cd xpdeint; waf/waf-light configure
	make clean
	make -C userdoc/src clean
	dh_clean

get-userdoc-tarball:
	( CURDIR=$$(pwd) ; 						\
	  TMPDIR=$$(mktemp -d) ;					\
	  cd $$TMPDIR ;							\
	  svn checkout https://svn.code.sf.net/p/xmds/code/trunk xmds ;	\
	  cd xmds/xpdeint/admin/ ; 					\
	  mkdir userdoc ;						\
	  mv userdoc-source userdoc/src ;				\
	  tar cfvJ xmds2-userdoc.tar.xz userdoc ;			\
	  mv xmds2-userdoc.tar.xz $$CURDIR ;				\
	  echo rm -rf $$TMPDIR )

=== debian/tests/control ===
Tests: run-tests
Depends: xmds2, octave, gnuplot-nox, fonts-freefont-otf
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Source: http://sf.net/xmds/
Matching-Pattern: xmds-([0-9].+)\.tar\.gz
Compression: xz
Dversionmangle: s/[~+]dfsg[0-9]*//
Repacksuffix: +dfsg
Uversionmangle: s/^xmds-/xmds2-/;s/-rc/~rc/
